module IESD
  class DMG

    # {Install OS X.dmg}[rdoc-ref:IESD::DMG::InstallOSX]
    #
    # The installer dmg for OS X Mavericks and later.
    # It contains an {Install OS X.app}[rdoc-ref:IESD::APP::InstallOSX].
    # It's generated by `createinstallmedia`, a tool come with the installer app.
    class InstallOSX < HDIUtil::DMG

      # Export to a new DMG.
      #
      # options - The Dictionary of the export options
      def export options
        show { |mountpoint|
          IESD::APP::InstallOSX.new(Dir[File.join(mountpoint, "*.app")][0]).export options
        }
      end
    end
  end
end
